/*
 * main implementation: use this 'C' sample to create your own application
 *
 */


#include "S32K144.h" /* include peripheral declarations S32K144 */
#include "clocks_and_modes.h"
#include "config.h"

void WDOG_disable (void){

  WDOG->CNT=0xD928C520; 	/* Unlock watchdog */
  WDOG->TOVAL=0x0000FFFF;	/* Maximum timeout value */
  WDOG->CS = 0x00002100;    /* Disable watchdog */
}

void PORT_init (void) {

//	 PTD->PSOR |= 1<<6;//VIG  //控制引脚供电

	//------------------------PORTA------------------------------------//
	  PCC->PCCn[PCC_PORTA_INDEX ] |= PCC_PCCn_CGC_MASK;

	  PORTA->PCR[8] &=PORT_PCR_MUX_MASK;//串口2引脚
	  PORTA->PCR[8] |=PORT_PCR_MUX(2);

	  PORTA->PCR[9] &=PORT_PCR_MUX_MASK;
	  PORTA->PCR[9] |=PORT_PCR_MUX(2);


	//----------------------------PORTB---------------------------//
	  PCC->PCCn[PCC_PORTB_INDEX ]|=PCC_PCCn_CGC_MASK;   /* Enable clock for PORTD */

		PORTB->PCR[1] &=PORT_PCR_MUX_MASK;
		PORTB->PCR[1] |=PORT_PCR_MUX(2);

		PORTB->PCR[0] &=PORT_PCR_MUX_MASK;
		PORTB->PCR[0] |=PORT_PCR_MUX(2);//串口0引脚

   //----------------------------PORTC---------------------------//
	  PCC->PCCn[PCC_PORTC_INDEX ]|=PCC_PCCn_CGC_MASK; /* Enable clock for PORTC */

   //-----------------------------PORTD-----------------///
	  PCC->PCCn[PCC_PORTD_INDEX ]|=PCC_PCCn_CGC_MASK; /* Enable clock for PORTC */
	  PORTD->PCR[7]|=PORT_PCR_MUX(1);
	  PTD->PDDR |= 1<<7;

	  PORTD->PCR[13]|=PORT_PCR_MUX(3);           /* Port D13: MUX = ALT3,UART1 RX */
	  PORTD->PCR[14]|=PORT_PCR_MUX(3);           //串口1引脚配置


   //------------------------------------------PORTE------------------
	  PCC->PCCn[PCC_PORTE_INDEX] |= PCC_PCCn_CGC_MASK; /* Enable clock for PORTE */
}

void UART0_init(void)
{
	PCC->PCCn[PCC_LPUART0_INDEX] &= ~PCC_PCCn_CGC_MASK;
	PCC->PCCn[PCC_LPUART0_INDEX] |= PCC_PCCn_PCS(0b001)   // Clock Src= 1 (SOSCDIV2_CLK)
                               		| PCC_PCCn_CGC_MASK;

	LPUART0->BAUD = 0x09000007;//0x0F00000D;//0x0F000034;//0x0F000009; //0x09000007;//115200
                           		 // SBR=52 (0x34):  = 8M/9600/16 = ~52
                           		 // OSR=15: 15+1=16
                           		 // SBNS=0:
                           		 // BOTHEDGE=0:
                           		 // M10=0:
                           		 // RESYNCDIS=0:
                           		 // LBKDIE, RXEDGIE=0:
	LPUART0->CTRL=0x2C0000;//接收中断使能
	//等待开启成功
	while(!(LPUART0->CTRL & LPUART_CTRL_TE_MASK));
	//清接收中断标志位RDRF，若未接好串口线，有可能会一直接收到数据0
	LPUART0->DATA ;
}

void UART1_init(void)
{
	PCC->PCCn[PCC_LPUART1_INDEX] &= ~PCC_PCCn_CGC_MASK;
	PCC->PCCn[PCC_LPUART1_INDEX] |= PCC_PCCn_PCS(0b001)   // Clock Src= 1 (SOSCDIV2_CLK)
                               		| PCC_PCCn_CGC_MASK;

	LPUART1->BAUD = 0x09000007;//0x0F00000D;//0x0F000034;//0x0F000009; //0x09000007;//115200
                           		 // SBR=52 (0x34):  = 8M/9600/16 = ~52
                           		 // OSR=15: 15+1=16
                           		 // SBNS=0:
                           		 // BOTHEDGE=0:
                           		 // M10=0:
                           		 // RESYNCDIS=0:
                           		 // LBKDIE, RXEDGIE=0:
//	LPUART1->CTRL=0x004C0000; //| (1<<28);//接收使能（接收和发送使能）

	LPUART1->CTRL=0x2C0000;//接收中断使能

//	LPUART1->CTRL=0x000C0000 | (1<<21);
//	LPUART1->CTRL=0x000C0000;

//	LPUART1->CTRL=0x00400000 | (1<<19);//传输使能
	//等待开启成功
	while(!(LPUART1->CTRL & LPUART_CTRL_TE_MASK));
	//清接收中断标志位RDRF，若未接好串口线，有可能会一直接收到数据0
	LPUART1->DATA ;
}

void UART1_NVIC_init_IRQs(void)
{
	uint32_t a=(uint32_t)(LPUART1_RxTx_IRQn) >> 5U;
	int32_t x=(uint32_t)(1UL << ((uint32_t)(LPUART1_RxTx_IRQn) & (uint32_t)0x1FU));
	//x=~x;
	S32_NVIC->ICPR[1] = 1 << (LPUART1_RxTx_IRQn % 32);  /* IRQ48-UART2: clr any pending IRQ*///清除挂起寄存器
	S32_NVIC->ISER[(uint32_t)(LPUART1_RxTx_IRQn) >> 5U] |= (uint32_t)(1UL << ((uint32_t)(LPUART1_RxTx_IRQn) & (uint32_t)0x1FU));//中断使能
	S32_NVIC->IP[LPUART1_RxTx_IRQn] = 0x7;              /* IRQ48-UART2: priority 7 of 0-15*///设置中断优先级
}

void UART2_init(void)
{
	PCC->PCCn[PCC_LPUART2_INDEX] &= ~PCC_PCCn_CGC_MASK;
	PCC->PCCn[PCC_LPUART2_INDEX] |= PCC_PCCn_PCS(0b001)   // Clock Src= 1 (SOSCDIV2_CLK)
                               		| PCC_PCCn_CGC_MASK;

	LPUART2->BAUD = 0x09000007;
	LPUART2->CTRL=0x000C0000; //传输和接收使能
}

void UART2_NVIC_init_IRQs(void)
{
		S32_NVIC->ICPR[1] = 1 << (LPUART2_RxTx_IRQn % 32);  /* IRQ48-UART2: clr any pending IRQ*///清除挂起寄存器
		uint32_t a2=(uint32_t)(LPUART2_RxTx_IRQn) >> 5U;
		uint32_t x2=(uint32_t)(1UL << ((uint32_t)(LPUART2_RxTx_IRQn) & (uint32_t)0x1FU));
		S32_NVIC->ISER[(uint32_t)(LPUART2_RxTx_IRQn) >> 5U] |= (uint32_t)(1UL << ((uint32_t)(LPUART2_RxTx_IRQn) & (uint32_t)0x1FU));//中断使能
		S32_NVIC->IP[LPUART2_RxTx_IRQn] = 0xA;             /* IRQ48-UART2: priority 7 of 0-15*///设置中断优先级

//		S32_NVIC->ICER[(uint32_t)(LPUART1_RxTx_IRQn) >> 5U] = (uint32_t)(1UL << ((uint32_t)(LPUART1_RxTx_IRQn) & (uint32_t)0x1FU));//串口1中断禁止
//		S32_NVIC->ICER[(uint32_t)(LPUART2_RxTx_IRQn) >> 5U] = (uint32_t)(1UL << ((uint32_t)(LPUART2_RxTx_IRQn) & (uint32_t)0x1FU));//串口2中断禁止

}



int main(void)
{
#define COUNTER_LIMIT 999999

	  DISABLE_INTERRUPTS(); // 关总中断

    WDOG_disable();
    SOSC_init_8MHz();       /* Initialize system oscillator for 8 MHz xtal */
    SPLL_init_160MHz();     /* Initialize SPLL to 160 MHz with 8 MHz SOSC */
    NormalRUNmode_80MHz();  /* Init clocks: 80 MHz sysc88k & core, 40 MHz bus, 20 MHz flash */


    PORT_init();

    UART1_init();
    UART1_NVIC_init_IRQs();
    UART2_init();
    UART0_init();

    LPIT0_init();                     //配置LPIT0
    LPIT0_NVIC_init_IRQs();           //配置LPIT0中断优先级

    ENABLE_INTERRUPTS();   //开总中断


        int counter = 0;
        for(;;) {       
            counter++;

            if(counter > COUNTER_LIMIT) {

            	counter=0;
            }
        }

    /* to avoid the warning message for GHS and IAR: statement is unreachable*/
#if defined (__ghs__)
#pragma ghs nowarning 111
#endif
#if defined (__ICCARM__)
#pragma diag_suppress=Pe111
#endif
	return 0;
}
